<?php
class Zencoder_ZencoderJob {

  var $new_job_url = "https://app.zencoder.com/api/jobs";
  var $new_job_params = array();
  var $created = false;
  var $errors = array();

  // Attributes
  var $id;
  var $test;
  var $state;

  var $outputs = array();

  // Initialize
  public function __construct($params, $options = array()) {

    // Build using params if not sending request
    if(@$options["build"]) {
      $this->update_attributes($params);
      return true;
    }

    if(@$options["url"]) $this->new_job_url = $options["url"];
    $this->new_job_params = $params;
    $this->created = $this->create();
  }

  // Send Job Request to API
  public function create() {
    // Send request
    $request = new Zencoder_ZencoderRequest($this->new_job_url, false, $this->new_job_params);

    if($request->successful) {
      $this->update_attributes($request->results);
      return true;
    } else {
      $this->errors = array_merge($this->errors, $request->errors);
      return false;
    }
  }

  // Add/Update attributes on the job object.
  public function update_attributes($attributes = array()) {
    foreach($attributes as $attr_name => $attr_value) {
      // Create output file objects
      if($attr_name == "outputs" && is_array($attr_value)) {
        $this->create_outputs($attr_value);
      } elseif (!function_exists($this->$attr_name)) {
        $this->$attr_name = $attr_value;
      }
    }
  }

  // Create output file objects from returned parameters.
  // Use the Label for the key if avaiable.
  public function create_outputs($outputs = array()) {
    foreach($outputs as $output_attrs) {
      if($output_attrs["label"]) {
        $this->outputs[$output_attrs["label"]] = new Zencoder_ZencoderOutputFile($output_attrs);
      } else {
        $this->outputs[] = new Zencoder_ZencoderOutputFile($output_attrs);
      }
    }
  }
}
